/*
*  Plugin is used to stop IE from using built-in dragging for certain tags
* 
*  Distributed under the terms of the GNU Library General Public License
*
*  @package ddi (Drag'n'Drop Interface)
*  @version 1.1
*  @title Fix IE drag
*  @author Ilya Lebedev (ilya@lebedev.net), (c) 2005
*
*  Revision history
*  v1.1
*  + plugin group DDI_CORE
*  + check of node parents for specified tags
*
*  v1.0
*  + first public release
*/
__DDI__.plugin.fixDragInIe = new function () {
  this.name = 'Fix IE drag';
  this.description = "Plugin stops IE's built-in drag'n'drop for links and images";
  this.group = 'DDI_CORE';
  /*
  *  Tags list to check
  *
  *  @var object
  *  @access privat
  */
  var tags = {'a':true,'img':true};
  this.dragstart = {
    'after' : function (e) {
       el = e.__target
       while (el) {
         if (tags[String(el.tagName).toLowerCase()]) el.attachEvent('ondragstart',__DDI__.plugin.fixDragInIe.noIeDrag);
         el = el.parentNode
       }
    }
  },
  /*
  *  Event handler, attached to some of the tags
  *
  *  @param object event object
  *  @return bool false
  *  @access public
  */
  this.noIeDrag = function (e) {
    e.cancelBubble = true;
    e.returnCalue = false;
    return false;
  }
};
