/*
*  Plugin shows only pointer cursor during drag
*
*  Distributed under the terms of the GNU Library General Public License
*
*  @package ddi (Drag'n'Drop Interface)
*  @version 1.2
*  @title Lock mouse cursor plugin
*  @author Ilya Lebedev (ilya@lebedev.net), (c) 2005
*
*  Revision history
*  v1.2
*  + plugin group DDI_VISUAL
*
*  v1.1
*  + first public release
*/
__DDI__.plugin.lockCursorAsDefault = new function() {
  this.name = 'Lock cursor';
  this.description = 'Plugin is used to show default mouse pointer during drag operation';
  this.group = 'DDI_VISUAL';
  var curel = null;
  this.drag = {
    'before' : function(e) {
      if (e.__target != curel) {
        if (curel && curel.style) curel.style.cursor = curel.__old_cursor;
        curel = e.__target;
        if (curel.style) {
          curel.__old_cursor = curel.style.cursor;
          curel.style.cursor = 'default';
        }
      }
      return true;
    }
  }
  this.dragend = {
    'before' : function(e) {
      if (curel && curel.style) curel.style.cursor = curel.__old_cursor;
      return true;
    }
  }
}
